
.data
szOper01       db  '+-*,.[]()<>="',0
;FontPrint      LOGFONT <-10,0,0,0,600,FALSE,FALSE,FALSE,0,0,0,0,0,'Courier New'>
FontPrint      LOGFONT <-10,0,0,0,600,FALSE,FALSE,FALSE,0,0,0,0,0,'Courier New'>

FontTah        db  'Tahoma',0

szNameAddress  db  'N A M E   A N D   A D D R E S S',0
DatePict       db  "MM'-'dd'-'yyyy",0
TimePict       db  "hh':'mm':'ss tt",0 

szPhone        db  'Phone: ',0
szFax          db  'Fax:   ',0
szEmail        db  'Email: ',0

szCR           db  0dh,0
szPerR         db  ')',0
TAB            dd  3
szSpace32      db  '                                ',0

.data?
InchesOn       dd  ?
PageSize       dd  ?
PrtHeading     dd  ?
PrtColor       dd  ?

;---------- [Structures] ----------
psd            PAGESETUPDLG <>

.code

;===================================================
; Convert to pixels PROCEDURE
;===================================================
ConvToPix PROC PixelsPerIn:DWORD, VarSize

         mov     eax, PixelsPerIn
      .if InchesOn
           imul     eax, 10

      .else
           imul     eax, 1000
            xor     edx, edx
            mov     ecx, 254
            div     ecx
      .endif
         mov     ecx, eax
         mov     eax, VarSize
        imul     eax, ecx
         xor     edx, edx
         mov     ecx, 10000
         div     ecx
         ret

ConvToPix ENDP

;===================================================
; Print document PROCEDURE
;===================================================
Print PROC uses ebx esi edi
LOCAL    tm:TEXTMETRIC
LOCAL    pd:PRINTDLG
LOCAL    doci:DOCINFO
LOCAL    pt:POINT
LOCAL    sz:SIZEL
LOCAL    cr:CHARRANGE
LOCAL    rect:RECT
LOCAL    hFontHead:DWORD, hFontPrt, PtrX, PtrY, PaperX, PaperY, mL, mT, mR, mB, CurLine
LOCAL    LinesLeft:DWORD, TabWth, hRgn, PageNum, OffSetX, OffSetY, AvgCharWth, MaxLine, hDC, IncrL
LOCAL    Cnt:DWORD, hFont
LOCAL    szBuff0[256]:BYTE, TimeBuff[32]:BYTE
LOCAL    PrtBuff[1024*2]:BYTE, PrtBuff01[1024*2]:BYTE

      INVOKE     SendMessage, hCurrent, EM_EXGETSEL, 0, addr cr
         mov     eax, cr.cpMin
      .if Field != 0 || eax == cr.cpMax
         INVOKE     MessageBox, NULL, addr szError5, addr AppName,\
                    MB_OK or MB_ICONWARNING or MB_SYSTEMMODAL
            ret
      .endif
         and     Cnt, 0
         mov     edx, hLineStruc
         mov     ecx, ScreenLine
         add     ecx, TopLine
         mov     esi, [edx+ecx*4].LINE.rpLine
         lea     edi, PrtBuff01
         mov     byte ptr[edi], 0
      INVOKE     lstrcpyn, addr szBuff0, addr szSpace32, 2
      INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.NameF
      INVOKE     lstrcat, edi, addr szBuff0
      .if [esi].NAMEADRESS.MI
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.MI
         INVOKE     lstrcat, edi, addr szBuff0
      .endif
      INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.NameL
      INVOKE     lstrcat, edi, addr szCR
      INVOKE     lstrcat, edi, addr szCR

      INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Address01
      INVOKE     lstrcat, edi, addr szCR
      INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Address02
      INVOKE     lstrcat, edi, addr szCR
      .if [esi].NAMEADRESS.Address03
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Address02
         INVOKE     lstrcat, edi, addr szCR
      .endif
      INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Zip
      INVOKE     lstrcat, edi, addr szCR
      INVOKE     lstrcat, edi, addr szCR
      .if [esi].NAMEADRESS.Phone
         INVOKE     lstrcat, edi, addr szPhone
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.PhoneA
         INVOKE     lstrcat, edi, addr szBuff0
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Phone
         INVOKE     lstrcat, edi, addr szCR
      .endif
      .if [esi].NAMEADRESS.Fax
         INVOKE     lstrcat, edi, addr szFax
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.FaxA
         INVOKE     lstrcat, edi, addr szBuff0
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Fax
         INVOKE     lstrcat, edi, addr szCR
         INVOKE     lstrcat, edi, addr szCR
      .endif
      .if [esi].NAMEADRESS.Email
         INVOKE     lstrcat, edi, addr szEmail
         INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Email
         INVOKE     lstrcat, edi, addr szCR
         INVOKE     lstrcat, edi, addr szCR
      .endif
      INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Comments

;---------- [Zero out the structures] ----------
      INVOKE     RtlZeroMemory, addr pd, sizeof pd
      INVOKE     RtlZeroMemory, addr doci, sizeof doci

      INVOKE     GetDC, hWnd
         mov     hDC, eax

;---------- [Get page size
      INVOKE     lstrcpy, addr lf.lfFaceName, addr FontPrint.lfFaceName
      INVOKE     GetDeviceCaps, hDC, LOGPIXELSY
         mov     ecx, FontPrint.lfHeight
         neg     ecx
         mul     ecx
         xor     edx, edx
         mov     ecx, 72
         div     ecx
         neg     eax
         mov     lf.lfHeight, eax
         mov     eax, FontPrint.lfWeight
         mov     lf.lfWeight, eax
      INVOKE     CreateFontIndirect, addr lf
         mov     hFontPrt, eax


      INVOKE     SelectObject, hDC, hFontPrt
      INVOKE     GetDeviceCaps, hDC, LOGPIXELSY
        imul     eax, 10
        push     eax
      INVOKE     GetTextMetrics, hDC, addr tm
         pop     eax
         xor     edx, edx
         mov     ecx, tm.tmHeight
;         add     ecx, tm.tmInternalLeading
;         add     ecx, tm.tmExternalLeading
         div     ecx
      .if edx
              inc     eax
      .endif
         mov     PageSize, eax
      INVOKE     ReleaseDC, hREdit, hDC
      INVOKE     DeleteObject, hFontPrt

      INVOKE     GetUserDefaultLCID
         mov     edx, eax
      INVOKE     GetLocaleInfo, edx, LOCALE_IMEASURE, addr szBuff0, sizeof szBuff0
         mov     InchesOn, 1
      .if byte ptr szBuff0 != '1'
            mov     InchesOn, 0
      .endif

         mov     pd.lStructSize,  sizeof pd
       MOVmd     pd.hwndOwner, hWnd
       MOVmd     pd.hInstance, hInst

         mov     eax, LineCnt
         mov     ecx, PageSize
         xor     edx, edx
         div     ecx
      .if edx
            inc     eax
      .endif
         mov     pd.nMinPage, 1
         mov     pd.nMaxPage, ax
         mov     pd.nFromPage, 1
         mov     pd.nToPage, ax
         mov     eax, PD_RETURNDC or PD_NOSELECTION or PD_ALLPAGES

         mov     pd.Flags, eax
      INVOKE     PrintDlg, addr pd
      .if eax
         INVOKE     GetDateFormat, NULL, NULL, NULL, offset DatePict, addr TimeBuff, 12
            mov     dword ptr TimeBuff[10], '    '
         INVOKE     GetTimeFormat, NULL, TIME_FORCE24HOURFORMAT, NULL, offset TimePict, addr TimeBuff[12], 12
            mov     dword ptr szBuff0, 00202020h
         INVOKE     lstrcat, addr TimeBuff, addr szBuff0

         INVOKE     GetDeviceCaps, pd.hDC, PHYSICALOFFSETX ; = device units left/right margin
            mov     OffSetX, eax
         INVOKE     GetDeviceCaps, pd.hDC, PHYSICALOFFSETY ; = device units top/bottom margin
            mov     OffSetY, eax
         INVOKE     GetDeviceCaps, pd.hDC, LOGPIXELSX
            mov     ebx, eax
         INVOKE     ConvToPix, ebx, psd.ptPaperSize.x
            mov     PaperX, eax
         INVOKE     ConvToPix, ebx, psd.rtMargin.left
            mov     mL, eax
         INVOKE     ConvToPix, ebx, psd.rtMargin.right
            mov     mR, eax
         INVOKE     GetDeviceCaps, pd.hDC, LOGPIXELSY
            mov     ebx, eax
         INVOKE     ConvToPix, ebx, psd.ptPaperSize.y
            mov     PaperY, eax
         INVOKE     ConvToPix, ebx, psd.rtMargin.top
            mov     mT, eax
         INVOKE     ConvToPix, ebx, psd.rtMargin.bottom
            mov     mB, eax
            mov     eax, OffSetX
            mov     ecx, OffSetY
            sub     mL, eax
            sub     mT, ecx
            add     mR, eax
            add     mB, ecx
;         INVOKE     RtlZeroMemory, addr lf, sizeof lf
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontPrint.lfFaceName
         INVOKE     GetDeviceCaps, pd.hDC, LOGPIXELSY
            mov     ecx, FontPrint.lfHeight
            neg     ecx
            mul     ecx
            xor     edx, edx
            mov     ecx, 72
            div     ecx
            neg     eax
            mov     lf.lfHeight, eax
            mov     eax, FontPrint.lfWeight
            mov     lf.lfWeight, eax
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontPrt, eax

         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontTah
            mov     lf.lfHeight, 52
            mov     lf.lfWeight, 600
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontHead, eax

            mov     lf.lfHeight, 42
            mov     lf.lfWeight, 400
         INVOKE     CreateFontIndirect, addr lf
            mov     hFont, eax

            mov     doci.cbSize, sizeof doci
            mov     doci.lpszDocName, offset AppName
            mov     doci.lpszOutput, NULL
            mov     doci.lpszDatatype, NULL
            mov     doci.fwType, NULL
         INVOKE     StartDoc, pd.hDC, addr doci
          movzx     eax, pd.nFromPage
            dec     eax
            mov     PageNum, eax
           imul     eax, PageSize
            mov     CurLine, eax
            mov     eax, LineCnt
             or     eax, eax
             je     AllDone
            mov     LinesLeft, eax

            mov     eax, mL
            mov     rect.left, eax
            mov     eax, PaperX
            sub     eax, mR
            mov     rect.right, eax
            mov     eax, mT
            mov     rect.top, eax
            mov     eax, PaperY
            sub     eax, mB
            mov     rect.bottom, eax
         INVOKE     CreateRectRgn, rect.left, rect.top, rect.right, rect.bottom
            mov     hRgn, eax

NextPage:
            inc     PageNum
            mov     eax, PageNum
         .if ax > pd.nToPage
               jmp     AllDone
         .endif
         INVOKE     StartPage, pd.hDC
            mov     eax, mT
            mov     PtrY, eax
         INVOKE     SelectObject, pd.hDC, hFontPrt
         INVOKE     SelectObject, pd.hDC, hRgn

;---------- [Get average character width and max line
            mov     eax, 'W i.'
            mov     dword ptr szBuff0, eax
         INVOKE     GetTextExtentPoint32, pd.hDC, addr szBuff0, 4, addr pt
            mov     eax, pt.x
            shr     eax, 2
            mov     AvgCharWth, eax
            xor     edx, edx
            mov     eax, rect.right
            mov     ecx, AvgCharWth
            div     ecx
            dec     eax
            mov     MaxLine, eax

;---------- [Get tab width
            mov     eax, 'WWWW'
            mov     dword ptr szBuff0, eax
         INVOKE     GetTextExtentPoint32, pd.hDC, addr szBuff0, 4, addr pt
            mov     eax, pt.x
            shr     eax, 2
           imul     eax, TAB
            mov     TabWth, eax
           push     pt.y

            and     IncrL, 0

mov     PrtHeading, 1
mov     PrtColor, 1

;---------- [Page number
         .if PrtHeading
            INVOKE     SelectObject, pd.hDC, hFontHead
               mov     eax, 'gaP('
               mov     dword ptr szBuff0, eax
               mov     word ptr szBuff0[4], ' e'
            INVOKE     BaseAscii, PageNum, addr szBuff0[6], 0, 10, 0, 1, 1
            INVOKE     lstrcat, addr szBuff0, addr szPerR
            INVOKE     lstrcpy, addr PrtBuff, addr TimeBuff
            INVOKE     lstrcat, addr PrtBuff, addr szBuff0
            INVOKE     lstrlen, addr szNameAddress
               mov     ebx, eax
               mov     eax, mL
               mov     PtrX, eax

            .if PrtColor
               INVOKE     SetTextColor, pd.hDC, 00ff0000h
            .endif
            INVOKE     TextOut, pd.hDC, PtrX, PtrY, addr szNameAddress, ebx
            INVOKE     lstrlen, addr PrtBuff
               mov     ebx, eax
            INVOKE     GetTextExtentPoint32, pd.hDC, addr PrtBuff, ebx, addr pt
               mov     eax, PaperX
               sub     eax, mR
               sub     eax, pt.x
               mov     PtrX, eax
              push     pt.x
            .if PrtColor
               INVOKE     SetTextColor, pd.hDC, 00ffff00h
            .endif
            INVOKE     lstrlen, addr PrtBuff
               mov     ebx, eax
            INVOKE     TextOut, pd.hDC, PtrX, PtrY, addr TimeBuff, ebx

            INVOKE     lstrlen, addr szBuff0
               mov     ebx, eax
            INVOKE     GetTextExtentPoint32, pd.hDC, addr szBuff0, ebx, addr pt
               pop     ecx
               mov     eax, pt.x
               add     PtrX, ecx
               sub     PtrX, eax
            .if PrtColor
               INVOKE     SetTextColor, pd.hDC, 00000000h
            .endif
            INVOKE     TextOut, pd.hDC, PtrX, PtrY, addr szBuff0, ebx

               mov     eax, pt.y
               add     PtrY, eax
               shr     eax, 1
               add     PtrY, eax
               mov     eax, mL
               mov     PtrX, eax
            INVOKE     lstrlen, addr PrtBuff01

               lea     esi, PrtBuff01
               xor     ebx, ebx
               mov     Cnt, eax
            .while (Cnt)
                  mov     al, byte ptr[esi]
               .if al != 0dh
                     mov     byte ptr szBuff0[ebx], al
                     inc     ebx
                     mov     byte ptr szBuff0[ebx], 0
               .else
                  INVOKE     lstrlen, addr szBuff0
                  INVOKE     TextOut, pd.hDC, PtrX, PtrY, addr szBuff0, ebx
                     mov     eax, pt.y
                     add     PtrY, eax
                     xor     ebx, ebx
               .endif
                  inc     esi
                  dec     Cnt
            .endw
               and     LinesLeft, 0
               jmp     EndOfPage
         .endif

EndOfPage:
         INVOKE     EndPage, pd.hDC
         .if LinesLeft
               jmp     NextPage
         .endif
            jmp     AllDone

;________________________________________________________

AllDone:
         INVOKE     EndDoc, pd.hDC
         INVOKE     DeleteDC, pd.hDC
         INVOKE     DeleteObject, hFontHead
         INVOKE     DeleteObject, hFontPrt
         INVOKE     DeleteObject, hFont
         INVOKE     DeleteObject, hRgn
      .endif
         ret

Print ENDP
