         title   Name Address

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  Windows.inc
            include  user32.inc
            include  kernel32.inc
            include  gdi32.inc
            include  comctl32.inc
            include  comdlg32.inc
            include  advapi32.inc

            include  L:\AsmEdit\include\DSPMACRO.asm

         includelib  user32.lib
         includelib  kernel32.lib
         includelib  gdi32.lib
         includelib  comctl32.lib
         includelib  comdlg32.lib
         includelib  advapi32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
RichEditProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ChgColor        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
AsciiBase       PROTO  :DWORD, :DWORD, :DWORD
BaseAscii       PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
ChgBmpColor     PROTO  :DWORD
RegQuerySZ      PROTO  :DWORD, :DWORD

TBSep    MACRO hTool
           mov     tbb.iBitmap, 0
           mov     tbb.idCommand, 0
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_SEP
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

TBButt   MACRO hTool, BmpID, CmdID, Text
           mov     tbb.iBitmap, BmpID    ; Button image number
           mov     tbb.idCommand, CmdID  ; Command ID number
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_BUTTON
           mov     tbb.dwData, 0
           mov     tbb.iString, Text
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

MOVmd    MACRO Var1, Var2
          push     Var2
           pop     Var1
          ENDM

.const
IDM_NEW        equ 1001
IDM_OPEN       equ 1002
IDM_SAVE       equ 1003
IDM_SAVEAS     equ 1004
IDM_PRINT      equ 1005
IDM_EXIT       equ 1006
IDM_SORTLA     equ 1007
IDM_SORTLD     equ 1008
IDM_SORTFA     equ 1009
IDM_SORTFD     equ 1010
IDM_SORTZIP    equ 1011
IDM_CUT        equ 1012
IDM_COPY       equ 1013
IDM_PASTE      equ 1014
IDM_SELALL     equ 1015
IDM_DELETE     equ 1016
IDM_CHOOSEF    equ 1017
IDM_CHOOSEC    equ 1018
IDM_FIND       equ 1019
IDM_FINDNEXT   equ 1020
IDM_FINDPREV   equ 1021
IDM_REPLACE    equ 1022

.data
AppName        db  'N A M E   A N D   A D D R E S S',0
ClassName      db  'NameAdress',0

RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0
ToolClass      db  'ToolbarWindow32',0
StatClass      db  'msctls_statusbar32',0
ScrollClass    db  'scrollbar',0
ButtonClass    db  'button',0
StaticClass    db  'static',0
EditClass      db  'edit',0
ListboxClass   db  'listbox',0

FontName       db  'MS Sans Serif',0
FontNameCN     db  'Courier New',0
MenuName       db  'MainMenu',0
SubMenuName    db  'SubMenu',0

LineData       db  ' Line: '
cnt1           db  '000001'
               db  '  of  '
cnt2           db  '000001'
               db  '    Field: '
cnt3           db  '0001',0

szButText01    db  'Find Text',0
szButText02    db  'Find Next',0
szOpenTitle    db  'Open File',0
szSaveTitle    db  'Save File As',0
szFilter       db  'Name Address',0,'*.nam',0,0
szNameAdress   db  '\NameAddr.nam',0

szError1       db  'The NameAdress.txt file is missing or is',0dh,0ah
               db  'corrupted.',0
szError2       db  'The file has been modified.',0dh,0ah
               db  'Do you wish to save it?',0
szError3       db  'There was a problem saving the file.',0dh,0ah,0
szError4       db  'The string above was not found',0dh,0ah
               db  'or no more occurrences.',0
szError5       db  'You must select a last name to print the line.',0dh,0ah,0

szREGSZ        db  'REG_SZ',0
szNameAddr     db  'Software\EW Software\NameAddr\',0

szNAddrColor   db  'Colors NAdress',0
szCustClrs     db  'Colors Cust',0

szText01       db  'Last Name',0
szText02       db  'First Name',0
szText03       db  'MI',0
szText04       db  'Address',0
szText05       db  'Zip',0
szText06       db  'Information',0
szText07       db  'Phone',0
szText08       db  'Fax',0
szText09       db  'Email',0
szText10       db  '[Comments]',0
TextArray      dd  szText01,szText02,szText03,szText04,szText05,szText06,
                   szText07,szText08,szText09,szText10

NameAddrColor  dd  00f0f0e4h,00cfff8fh,00aceaeah,00ffffcdh,00c0f0c0h,00c4ffffh,
                   00dadab6h,00000000h,007bf4a3h,00eaffeah,00000000h,00000000h

DefNAddrColor  dd  00f0f0e4h,00cfff8fh,00aceaeah,00ffffcdh,00c0f0c0h,00c4ffffh,
                   00dadab6h,00000000h,007bf4a3h,00eaffeah,00000000h,00000000h

DefCustColor   dd  00f0f0e4h,00e9e9e9h,00eaffeah,00ffffcdh,00c0f0c0h,00c4ffffh,
                   00edc7f8h,00cfff8fh,00c9c9ffh,00dadab6h,00aceaeah,008080ffh,
                   0078d0e0h,00fdfceeh,007bf4a3h,004bcc73h

szCar          db  '^',0
szZero         db  '0',0
szCRLF         db  0dh,0ah,0
szNULL         db  0

StatPS01       dd  4,29,100,17
StatPS02       dd  107,29,100,17
StatPS03       dd  210,29,20,17
StatPS04       dd  233,29,150,17
StatPS05       dd  386,29,45,17
StatPS06       dd  434,29,198,17
StatPS07       dd  587,49,45,17
StatPS08       dd  587,68,45,17
StatPS09       dd  587,87,45,17
StatPS10       dd  4,68,226,17

PS01           dd  4,29,100,17
PS02           dd  107,29,100,17
PS03           dd  210,29,20,17
PS04           dd  233,29,150,17
PS05           dd  233,48,150,17
PS06           dd  233,67,150,17
PS07           dd  386,67,45,17
PS08           dd  434,29,34,17
PS09           dd  471,29,113,17
PS10           dd  434,48,34,17
PS11           dd  471,48,113,17
PS12           dd  434,67,150,17
PS13           dd  4,67,226,17

;ColumnPos      dd  88,288,438,588,788,938,1288,1438,1788,1938,2338,2938
;ColumnWth      dd  200,150,150,200,150,350,150,350,150,400,600,180

ColumnPos      dd  88,288,438,588,788,938,1288,1438,1788,1938,2338,2938
ColumnWth      dd  200,150,150,200,150,350,150,350,150,400,600,180

Fields         dd  4,14,24,34,44,54,86,96,128,138,170,202

.data?
hREdDll        dd  ?
hInst          dd  ?
CommandLine    dd  ?
MainExit       dd  ?
hMenu          dd  ?
hSMenu         dd  ?
hWnd           dd  ?
hWndStat       dd  ?
hColor         dd  ?
sbParts        dd  4   dup(?)
hWndTool       dd  ?
hEdit          dd  ?
hButt01        dd  ?
hButt02        dd  ?
hScrollV       dd  ?
hScrollH       dd  ?
hNoGrip        dd  ?
lpRichEdit     dd  ?

hDefHeap       dd  ?
hBuff          dd  ?
hNameAddress   dd  ?
hLineStruc     dd  ?
hNAddressStruct    dd  ?

hBR            dd  ?
hBrush         dd  ?
LineHgt        dd  ?
BytesRead      dd  ?
ScreenLine     dd  ?
Field          dd  ?
TopLine        dd  ?
LineCnt        dd  ?
CurAddr        dd  ?
ChangeOn       dd  ?
DescendingOn   dd  ?
FirstNameOn    dd  ?
ZipOn          dd  ?
FindNextOn     dd  ?
ClearPointer   dd  ?
SaveFlag       dd  ?

SaveCode       dd  ?
ColorRes       dd  ?
IncrRes        dd  ?
ScrollPos      dd  ?
ScrollD        dd  ?
ScrollU        dd  ?

lpType         dd  ?
lpcbData       dd  ?
lpdwDisp       dd  ?
lpcbValueName  dd  ?
lpcValues      dd  ?

CustClrs       dd  16  dup(?)
hStat          dd  34  dup(?)
hREdit         dd  280 dup(?)

ToolH          dd  ?
StatH          dd  ?

hCurrent       dd  ?
hFontE         dd  ?
hFontS         dd  ?
hImageList     dd  ?
MenuCnt        dd  ?

IncrFind       dd  ?
Find1          dd  ?
Find2          dd  ?
Find3          dd  ?

Test4          dd  ?
Test5          dd  ?

PathName       db  256 dup(?)
FileName       db  32  dup(?)
szMiles        db  32  dup(?)

;---------- [Structures] ----------
.data
LINE struct
  rpLine       dd 0            ; Relative pointer to Line
LINE ends            

NAMEADRESS struct
   NameL       db 32 dup(?)  ;+0
   NameF       db 32 dup(?)  ;+32
   MI          db 02 dup(?)  ;+64
   Address01   db 40 dup(?)  ;+66
   Address02   db 40 dup(?)  ;+106
   Address03   db 40 dup(?)  ;+146
   Zip         db 12 dup(?)  ;+186
   PhoneA      db 06 dup(?)  ;+198
   Phone       db 32 dup(?)  ;+204
   FaxA        db 06 dup(?)  ;+236
   Fax         db 32 dup(?)  ;+242
   Email       db 64 dup(?)  ;+274
   Comments    db 128 dup(?) ;+338
   LineNum     dd 0          ;+466 + 4 = 470
NAMEADRESS ends

.data?
lf             LOGFONT         <?>
sci            SCROLLINFO      <?>

            include  Print.asm

.code
;1234567890123456789012345678901234567890

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls
      INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
         mov     hREdDll, eax

      INVOKE     GetProcessHeap
         mov     hDefHeap, eax

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     FreeLibrary, hREdDll

      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_HREDRAW or CS_VREDRAW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
      INVOKE     CreateSolidBrush, NameAddrColor[36]
         mov     hBrush, eax
         mov     wc.hbrBackground, eax ;COLOR_WINDOWTEXT+1 ;COLOR_BTNFACE+1
         mov     wc.lpszMenuName, 0 ;offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

      INVOKE     LoadMenu, hInst, offset MenuName
         mov     hMenu, eax
      INVOKE     LoadMenu, hInst, offset SubMenuName
      INVOKE     GetSubMenu, eax, 0
         mov     hSMenu, eax

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 700
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 575
         shr     eax, 1
         pop     ebx

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName,\
                 addr AppName, WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,\
                 ebx, eax, 664, 571, NULL, hMenu, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd
      INVOKE     CreateSolidBrush, NameAddrColor[36]
         mov     hBrush, eax
      INVOKE     SetClassLong, hWnd, GCL_HBRBACKGROUND, hBrush
      INVOKE     RedrawWindow, hWnd, 0, 0, RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
            .break .if (!eax)
            INVOKE     TranslateMessage, addr msg
            INVOKE     DispatchMessage, addr msg
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;===================================================
; WinProc procedure
;===================================================
WndProc proc  uses ebx esi edi hwnd:DWORD, wMsg, wParam, lParam
LOCAL    tbb:TBBUTTON
LOCAL    tbab:TBADDBITMAP
LOCAL    rect:RECT
LOCAL    bSize:DWORD, hTbBmp, ID, Cnt, Cnt1, Incr, dwStyle
LOCAL    szBuff[256]:BYTE

;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE
           call     Initialize

;---------- [Create the status bar window] ----------
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE or SBS_SIZEGRIP,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hWndStat, eax
         INVOKE     SendMessage, hWndStat, SB_SETBKCOLOR, 0, NameAddrColor[36]

;---------- [Create the Toolbar Window] ----------
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or WS_BORDER,\
                    0, -2, 1200, 26, hwnd, 0, hInst, 0
         .if !eax
;Do message
               jmp     Ret0
         .endif
            mov     hWndTool, eax

;---------- [Create the ImageList] ----------
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, 14, 0
            mov     hImageList, eax

;---------- [Load The Bitmaps] ----------
            mov     ID, 701           ; Bitmap ID start address
            mov     Cnt, 13           ; Number of bitmaps
         .while (Cnt)
            INVOKE     LoadImage, hInst, ID, IMAGE_BITMAP, 16, 16, LR_DEFAULTCOLOR
               mov     hTbBmp, eax
            INVOKE     ChgBmpColor, hTbBmp
               mov     hTbBmp ,eax
            INVOKE     ImageList_Add, hImageList, hTbBmp, NULL
            INVOKE     DeleteObject, hTbBmp
               inc     ID
               dec     Cnt
         .endw

         INVOKE     SendMessage, hWndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageList

;---------- [Size the Bitmap and Button] ----------
            mov     ecx, 16  ; loword = bitmap Width
            mov     eax, 16  ; hiword = bitmap Height
            shl     eax, 16
            mov     ax, cx
            mov     bSize, eax
         INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, bSize
         INVOKE     SendMessage, hWndTool, TB_SETBUTTONSIZE, 0, bSize

;---------- [Create the Toolbar structures] ----------
         TBButt     hWndTool, 0, IDM_NEW, 0
         TBButt     hWndTool, 1, IDM_OPEN, 0
         TBButt     hWndTool, 2, IDM_SAVE, 0
          TBSep     hWndTool
         TBButt     hWndTool, 3, IDM_CUT, 0
         TBButt     hWndTool, 4, IDM_COPY, 0
         TBButt     hWndTool, 5, IDM_PASTE, 0
         TBButt     hWndTool, 6, IDM_DELETE, 0
          TBSep     hWndTool
         TBButt     hWndTool, 7, IDM_EXIT, 0

;---------- [Create the Font] ----------
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
            mov     lf.lfHeight, -12
            mov     lf.lfWeight, 600
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontE, eax    ; Edit font

            mov     lf.lfHeight, -10
            mov     lf.lfWeight, 500
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontS, eax    ; Static font

;---------- [Create the VScroll Control] ----------
         INVOKE     CreateWindowEx, NULL, addr ScrollClass, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SBS_VERT,\
                    523, 28, 14, 316, hwnd, 2001, hInst, NULL
            mov     hScrollV, eax

;---------- [Create the HScroll Control] ----------
         INVOKE     CreateWindowEx, NULL, addr ScrollClass, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SBS_HORZ,\
                    25, 336, 467, 14, hwnd, 2002, hInst, NULL
            mov     hScrollH, eax

         INVOKE     CreateWindowEx, NULL, addr StaticClass, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_BORDER or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, NULL, hInst, NULL
            mov     hNoGrip, eax

;---------- [Create the find text edit Control] ----------
         INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
            mov     ecx, eax
            dec     ecx
         INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, ecx, addr rect
            add     rect.right, 3
         INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or ES_AUTOHSCROLL or ES_NOHIDESEL or ES_SAVESEL,\
                    rect.right, 3, 75, 16, hWndTool, 44, hInst, NULL
            mov     hEdit, eax
         INVOKE     SendMessage, hEdit, WM_SETFONT, hFontE, TRUE
         INVOKE     SendMessage, hEdit, EM_SETBKGNDCOLOR, 0, NameAddrColor[36]

;---------- [Create the find text button Control] ----------
            add     rect.right, 78
         INVOKE     CreateWindowEx, 0, addr ButtonClass, addr szButText01,\
                    WS_CHILD or WS_VISIBLE or BS_FLAT,\
                    rect.right, 3, 75, 16, hWndTool, 45, hInst, NULL
            mov     hButt01, eax

            add     rect.right, 78
         INVOKE     SendMessage, hButt01, WM_SETFONT, hFontE, TRUE
         INVOKE     CreateWindowEx, 0, addr ButtonClass, addr szButText02,\
                    WS_CHILD or WS_VISIBLE or BS_FLAT,\
                    rect.right, 3, 75, 16, hWndTool, 46, hInst, NULL
            mov     hButt02, eax
         INVOKE     SendMessage, hButt02, WM_SETFONT, hFontE, TRUE
         INVOKE     EnableWindow, hButt02, FALSE

;---------- [Create the Static Control Windows top] ----------
            lea     edi, TextArray
            xor     esi, esi
            and     Incr, 0
            mov     Cnt1, 10
         .while (Cnt1)
               mov     ecx, Incr
               mov     ebx, StatPS01[ecx+4]
               dec     ebx
               mov     dwStyle, WS_CHILD or WS_VISIBLE or SS_SUNKEN
            .if Cnt1 == 1
                   or     dwStyle, SS_CENTER
                  xor     dwStyle, SS_SUNKEN
                  add     ebx, 5
            .endif
            INVOKE     CreateWindowEx, NULL, addr StaticClass, [edi],\
                       dwStyle,\
                       StatPS01[ecx], ebx, StatPS01[ecx+8], StatPS01[ecx+12], hwnd, NULL, hInst, NULL
               mov     hStat[esi*4], eax
            .if Cnt1 == 1
               INVOKE     SendMessage, hStat[esi*4], WM_SETFONT, hFontS, TRUE
            .endif
               inc     esi
               add     edi, 4
               add     Incr, 16
               dec     Cnt1
         .endw

;---------- [Create the Static Control Windows side and comment] ----------
            mov     ID, 62
            mov     Cnt, 6
         .while (Cnt)
               lea     edi, TextArray
               add     edi, 24
               mov     Incr, 96
               mov     Cnt1, 4
            .while (Cnt1)
                  mov     ecx, Incr
                  mov     ebx, StatPS01[ecx+4]
                  add     ebx, ID
                  mov     dwStyle, WS_CHILD or WS_VISIBLE or SS_SUNKEN
               .if Cnt1 == 1
                      or     dwStyle, SS_CENTER
                     xor     dwStyle, SS_SUNKEN
                     add     ebx, 5
               .endif
               INVOKE     CreateWindowEx, NULL, addr StaticClass, [edi],\
                          dwStyle,\
                          StatPS01[ecx], ebx, StatPS01[ecx+8], StatPS01[ecx+12], hwnd, NULL, hInst, NULL
                  mov     hStat[esi*4], eax
               .if Cnt1 == 1
                  INVOKE     SendMessage, hStat[esi*4], WM_SETFONT, hFontS, TRUE
               .endif
                  inc     esi
                  add     edi, 4
                  add     Incr, 16
                  dec     Cnt1
            .endw
               add     ID, 63
               dec     Cnt
         .endw

;---------- [Create the Edit Control Windows] ----------
            xor     esi, esi
            xor     edi, edi
            mov     ebx, 19
            and     Incr, 0
            mov     ID, 3001
            mov     Cnt, 7
         .while (Cnt)
               xor     ecx, ecx
               mov     Cnt1, 13
            .while (Cnt1)
                  add     PS01[ecx+4], 19
                  add     ecx, 16
                  dec     Cnt1
            .endw
               mov     Cnt1, 13
            .while (Cnt1)
                  mov     ecx, Incr
                  mov     dwStyle, WS_CHILD or WS_VISIBLE or ES_AUTOHSCROLL or ES_NOHIDESEL or ES_SAVESEL
               .if Cnt1 == 11
                      or     dwStyle, ES_CENTER
               .endif
               INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr RichEdit, NULL,\
                          dwStyle,\
                          PS01[ecx], PS01[ecx+4], PS01[ecx+8], PS01[ecx+12], hwnd, ID, hInst, NULL
                  mov     hREdit[esi*4], eax
               INVOKE     SendMessage, hREdit[esi*4], WM_SETFONT, hFontE, TRUE
               INVOKE     SendMessage, hREdit[esi*4], EM_SETBKGNDCOLOR, 0, NameAddrColor[edi*4]
               INVOKE     SetWindowLong, hREdit[esi*4], GWL_WNDPROC, RichEditProc
                  mov     lpRichEdit, eax

;---------- [Set text limit for edit controls
               .if Cnt1 == 1
                     mov     ecx, 127
               .elseif Cnt1 == 2
                     mov     ecx, 63
               .elseif Cnt1 == 3 || Cnt1 == 5 || Cnt1 == 12 || Cnt1 == 13
                     mov     ecx, 31
               .elseif Cnt1 == 4 || Cnt1 == 6
                     mov     ecx, 5
               .elseif Cnt1 == 7
                     mov     ecx, 11
               .elseif Cnt1 == 8 || Cnt1 == 9 || Cnt1 == 10
                     mov     ecx, 39
               .elseif Cnt1 == 11
                     mov     ecx, 1
               .endif
               INVOKE     SendMessage, hREdit[esi*4], EM_EXLIMITTEXT, 0, ecx
                  inc     esi
                  add     Incr, 16
                  inc     ID
                  dec     Cnt1
            .endw

;---------- [Set height for next row
               xor     ecx, ecx
               mov     Cnt1, 13
            .while (Cnt1)
                  add     PS01[ecx+4], 44
                  add     ecx, 16
                  dec     Cnt1
            .endw
               inc     edi
               and     Incr, 0
               dec     Cnt
         .endw

         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 300
            mov     hBuff, eax
         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 2000000
            mov     hNameAddress, eax
         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 100000
            mov     hLineStruc, eax
         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 2000000
            mov     hNAddressStruct, eax

         INVOKE     GetWindowRect, hREdit[52], addr rect
            mov     edi, rect.top
         INVOKE     GetWindowRect, hREdit, addr rect
            sub     edi, rect.top
            sub     edi, 19
            mov     LineHgt, edi

            mov     sci.cbSize, sizeof sci
            mov     sci.fMask, SIF_ALL

           push     hwnd
            pop     hWnd

;---------- [Fill the page setup structure
            mov     psd.lStructSize, sizeof psd
           push     hWnd
            pop     psd.hwndOwner
           push     hInst
            pop     psd.hInstance
            mov     psd.rtMargin.left, 360
            mov     psd.rtMargin.top, 360
            mov     psd.rtMargin.right, 360
            mov     psd.rtMargin.bottom, 516
            mov     psd.ptPaperSize.x, 8500
            mov     psd.ptPaperSize.y, 11000

           call     LoadFile
          MOVmd     hCurrent, dword ptr hREdit
           call     CheckState
         INVOKE     SetFocus, hREdit

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE

;---------- [Size the Statusbar Control] ----------
            mov     eax, lParam       ; Get width
            and     eax, 0ffffh       ; Lowword
            shr     eax, 2            ; /4
            mov     ecx, eax          ; Save factor
            mov     sbParts, eax      ; Make part 1 1/4 the width
            add     eax, ecx
            add     eax, 35
            mov     [sbParts+4], eax  ; and also part2, .. etc
            add     eax, ecx
            mov     [sbParts+8], eax
            mov     [sbParts+12], -1  ; The last part extends to the end
         INVOKE     SendMessage, hWndStat, SB_SETPARTS, 4, addr sbParts
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE

            mov     ecx, ScreenLine
            inc     ecx
            add     ecx, TopLine
         INVOKE     BaseAscii, ecx, addr cnt1, 6, 10, 0, 1, 0
         INVOKE     BaseAscii, LineCnt, addr cnt2, 6, 10, 0, 1, 0
            mov     ecx, Field
            inc     ecx
         INVOKE     BaseAscii, ecx, addr cnt3, 4, 10, 0, 1, 0
         INVOKE     SendMessage, hWndStat, SB_SETTEXT, 1, addr LineData 

;---------- [Size the Toolbar Control] ----------
         INVOKE     SendMessage, hWndTool, TB_AUTOSIZE, 0, 0

         INVOKE     GetWindowRect, hWndTool, addr rect ; Rectangle of toolbar
            mov     eax, rect.bottom
            sub     eax, rect.top
            sub     eax, 3
            mov     ToolH, eax                            ; Toolbar height
         INVOKE     GetWindowRect, hWndStat, addr rect    ; Rectangle of statusbar
            mov     eax, rect.bottom
            sub     eax, rect.top
            mov     StatH, eax
         INVOKE     GetClientRect, hwnd, addr rect
            mov     eax, ToolH
            add     eax, StatH
            sub     rect.bottom, eax
            sub     rect.bottom, 14
            sub     rect.right, 16
         INVOKE     MoveWindow, hScrollV, rect.right, ToolH, 16, rect.bottom, TRUE
            mov     eax, ToolH
            add     rect.bottom, eax
         INVOKE     MoveWindow, hScrollH, 0, rect.bottom, rect.right, 16, TRUE
         INVOKE     MoveWindow, hNoGrip, rect.right, rect.bottom, 16, 17, TRUE

      .elseif wMsg == WM_CTLCOLORSTATIC
            mov     eax, lParam
         .if eax == hNoGrip
            INVOKE     GetSysColor, COLOR_BTNFACE
               mov     ebx, eax
         .else
               xor     esi, esi
               mov     ecx, 34
            .while (ecx)
               .if eax == hStat[esi*4]
                     mov     ebx, NameAddrColor[32]
                  .if esi > 5
                        mov     ebx, NameAddrColor[36]
                  .endif
               .endif
                  inc     esi
                  dec     ecx
            .endw
         .endif
         INVOKE     SetBkColor, wParam, ebx
         INVOKE     SetTextColor, wParam, NameAddrColor[44]
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, ebx
            mov     hBR, eax
            ret

      .elseif wMsg == WM_NOTIFY
            mov     ebx, lParam                      ; Get pointer to NMHDR
            mov     eax, (NMHDR ptr [ebx]).code
         .if eax == TTN_NEEDTEXT
               mov     eax, (NMHDR ptr [ebx]).idFrom ; Resource id
               mov     ebx, eax
            INVOKE     LoadString, hInst, ebx, addr szBuff, lengthof szBuff
               mov     ebx, lParam                   ; Get the buffer addr
               lea     eax, szBuff
               mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax
               jmp     Ret0
         .endif
         jmp     DefWin

      .elseif wMsg == WM_VSCROLL
            mov     edi, LineHgt
         INVOKE     GetScrollInfo, hScrollV, SB_CTL, addr sci
            mov     eax, wParam
            and     eax, 0ffffh

         .if eax == SB_LINEDOWN
            .if LineCnt >= 7                         ; Number of visible lines
                 call     ScrollDown
                  add     sci.nPos, edi
               INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE
            .endif

         .elseif eax == SB_LINEUP
            .if TopLine
                 call     ScrollUp
                  sub     sci.nPos, edi
               .if sdword ptr sci.nPos < 0
                     mov     sci.nPos, 0
               .endif
               INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE
            .endif

         .elseif eax == SB_THUMBPOSITION || eax == SB_THUMBTRACK
               xor     ebx, ebx
               mov     eax, sci.nTrackPos
            .if eax > ScrollPos
                  and     ScrollU, 0
                  xor     edx, edx
                  mov     ecx, LineHgt
                  div     ecx
               .if LineCnt >= 7
                  .if eax != ScrollD
                        mov     ScrollD, eax
                        mov     eax, LineHgt
                        add     sci.nPos, eax
                       call     ScrollDown
                  .endif
               .endif

            .elseif eax < ScrollPos
                 push     eax
                  and     ScrollD, 0
                  xor     edx, edx
                  mov     ecx, edi
                  div     ecx
                  pop     ecx
                  mov     ebx, LineHgt
               .if TopLine
                  .if eax != ScrollU
                        mov     ScrollU, eax
                        mov     eax, LineHgt
                        sub     sci.nPos, eax
                       call     ScrollUp
                  .endif
               .endif
               .if sdword ptr sci.nPos < 0
                     mov     sci.nPos, 0
               .endif
            .endif
            INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE
               mov     eax, sci.nPos
               add     eax, ebx
               mov     ScrollPos, eax

         .elseif eax == SB_ENDSCROLL
               mov     eax, sci.nPos
               mov     ScrollPos, eax
               and     ScrollU, 0
               and     ScrollD, 0
         .endif


;         INVOKE     UpdateWindow, hWnd

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                          ; Only low word contains command
         .if eax == IDM_NEW
            .if ChangeOn
               INVOKE     MessageBox, NULL, addr szError2, addr AppName,
                          MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_SYSTEMMODAL
               .if eax == IDYES
                    call     SaveFile

               .elseif eax == IDCANCEL
                     jmp     Ret0
               .endif
            .endif
               mov     PathName, 4
              call     LoadFile

         .elseif eax == IDM_OPEN
              call     OpenFileA

         .elseif eax == IDM_SAVE
              call     SaveFile

         .elseif eax == IDM_SAVEAS
               mov     SaveFlag, 1
              call     SaveFile

         .elseif eax == IDM_PRINT
              call     Print

         .elseif eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

         .elseif eax == IDM_CUT
            INVOKE     GetFocus
            .if eax
                  mov     ecx, eax
               INVOKE     SendMessage, ecx, WM_CUT, 0 ,0
                  mov     ChangeOn, 1
                 call     Update
            .endif

         .elseif eax == IDM_COPY
            INVOKE     GetFocus
            .if eax
                  mov     ecx, eax
               INVOKE     SendMessage, ecx, WM_COPY, 0 ,0
            .endif

         .elseif eax == IDM_PASTE
            INVOKE     GetFocus
            .if eax
                  mov     ecx, eax
               INVOKE     SendMessage, ecx, WM_PASTE, 0 ,0
                  mov     ChangeOn, 1
                 call     Update
                 call     CheckState
            .endif

         .elseif eax == IDM_SELALL
            INVOKE     GetFocus
            .if eax
                  mov     ecx, eax
               INVOKE     SendMessage, ecx, EM_SETSEL, 0, -1
                 call     CheckState
            .endif

         .elseif eax == IDM_DELETE
            INVOKE     GetFocus
            .if eax
                  mov     ecx, eax
               INVOKE     SendMessage, ecx, WM_CLEAR, 0 ,0
                  mov     ChangeOn, 1
                 call     Update
                 call     CheckState
            .endif

         .elseif eax == IDM_SORTLA
               and     FirstNameOn, 0
               and     ZipOn, 0
               and     DescendingOn, 0
              call     Sort ;QuickSortA ;SortA ;SortD ;BubbleSort

         .elseif eax == IDM_SORTLD
               and     FirstNameOn, 0
               and     ZipOn, 0
               mov     DescendingOn, 1
              call     Sort

         .elseif eax == IDM_SORTFA
               mov     FirstNameOn, 1
               and     ZipOn, 0
               and     DescendingOn, 0
              call     Sort

         .elseif eax == IDM_SORTFD
               mov     FirstNameOn, 1
               and     ZipOn, 0
               mov     DescendingOn, 1
              call     Sort

         .elseif eax == IDM_SORTZIP
               and     FirstNameOn, 0
               and     DescendingOn, 0
               mov     ZipOn, 1
              call     Sort

         .elseif eax == IDM_SELALL

         .elseif eax == IDM_CHOOSEF

         .elseif eax == IDM_CHOOSEC
            .if hColor
                  jmp     Ret0
            .endif
            INVOKE     CreateDialogParam, hInst, 4805, hWnd, addr ChgColor, 0
            .if eax
                  mov     hColor, eax
               INVOKE     SendMessage, hColor, WM_COMMAND, 200, 0
            .endif

         .elseif eax == IDM_FIND

         .elseif eax == IDM_FINDNEXT

         .elseif eax == IDM_FINDPREV

         .elseif eax == IDM_REPLACE

         .elseif eax == 44
               and     FindNextOn, 0
            INVOKE     EnableWindow, hButt01, TRUE
            INVOKE     EnableWindow, hButt02, FALSE

         .elseif eax == 45
               and     FindNextOn, 0
            INVOKE     SetFocus, hREdit
              call     FindString

         .elseif eax == 46
               mov     FindNextOn, 1
            INVOKE     SetFocus, hREdit
              call     FindString
         .endif

      .elseif wMsg == WM_CLOSE
         .if ChangeOn
            INVOKE     MessageBox, NULL, addr szError2, addr AppName,
                       MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_SYSTEMMODAL
            .if eax == IDYES
                 call     SaveFile
               .if eax == IDCANCEL
                     jmp     Ret0
               .endif
            .elseif eax == IDCANCEL
                  jmp     Ret0
            .endif
         .endif
           call     RegSave
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     ImageList_Destroy, hImageList
         INVOKE     HeapFree, hDefHeap, 0, hBuff
         INVOKE     HeapFree, hDefHeap, 0, hNameAddress
         INVOKE     HeapFree, hDefHeap, 0, hLineStruc
         INVOKE     HeapFree, hDefHeap, 0, hNAddressStruct
         INVOKE     DeleteObject, hFontE
         INVOKE     DeleteObject, hFontS
         INVOKE     DestroyWindow, hwnd

      .elseif wMsg == WM_DESTROY

         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret
WndProc endp

;===================================================
; Initialization PROCEDURE
;===================================================
Initialize PROC uses esi edi
LOCAL    hReg:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szNameAddr, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp

         mov     lpcbData, sizeof NameAddrColor
      INVOKE     RegQuerySZ, addr szNAddrColor, addr NameAddrColor
         mov     lpcbData, sizeof CustClrs
      INVOKE     RegQuerySZ, addr szCustClrs, addr CustClrs
      .if dword ptr CustClrs == 0 && dword ptr CustClrs[4] == 0
            lea     esi, DefCustColor
            lea     edi, CustClrs
            mov     ecx, 16
         .while (ecx)
               mov     eax, [esi]
               mov     [edi], eax
               add     esi, 4
               add     edi, 4
               dec     ecx
         .endw
      .endif

      INVOKE     RegCloseKey, hReg

         xor    eax, eax
         ret
Initialize ENDP

;===================================================
; SubClass the Edit control procedure
;===================================================
RichEditProc PROC hwnd:DWORD, wmsg, wparam, lparam
LOCAL    pt:POINT
LOCAL    rect:RECT

      .if wmsg == WM_KEYDOWN || wmsg == WM_CHAR
         INVOKE     GetWindowLong, hwnd, GWL_ID
           push     eax
            sub     eax, 3001
            mov     Field, eax
            mov     CurAddr, eax
            xor     edx, edx
            mov     ecx, 13
            div     ecx
            mov     ScreenLine, eax
            sub     Field, eax
         .if eax
               mov     ecx, 12
              imul     eax, ecx
               sub     Field, eax
         .endif
            pop     eax

         .if wparam == 26h                          ; Up arrow
               sub     eax, 3000
               mov     ecx, eax
               mov     CurAddr, eax
            .if ecx > 13                            ; Greater then first line
                  sub     ecx, 14
               INVOKE     SetFocus, hREdit[ecx*4]
                  sub     CurAddr, 12
                  inc     ScreenLine
            .elseif TopLine
               INVOKE     GetScrollInfo, hScrollV, SB_CTL, addr sci
                 call     ScrollUp
                  mov     eax, LineHgt
                  sub     sci.nPos, eax
               .if sdword ptr sci.nPos < 0
                     mov     sci.nPos, 0
               .endif
               INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE
                  mov     eax, sci.nPos
                  mov     ScrollPos, eax
            .endif
               mov     eax, 1
               ret
         .endif

         .if wparam == 28h                          ; Down arrow
               sub     eax, 3000
               mov     ecx, eax
               mov     CurAddr, eax
            .if ecx < 78                            ; Max number of controls - one line
                  add     ecx, 12
               INVOKE     SetFocus, hREdit[ecx*4]
                  add     CurAddr, 13
                  inc     ScreenLine
            .elseif LineCnt >= 7
               INVOKE     GetScrollInfo, hScrollV, SB_CTL, addr sci
                 call     ScrollDown
                  mov     eax, LineHgt
                  add     sci.nPos, eax
               INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE
                  mov     eax, sci.nPos
                  mov     ScrollPos, eax
            .endif
               mov     eax, 1
               ret
         .endif

;DSPValue hWnd, wparam, 1, 't'
         .if wparam == 9                            ; Tabstop
               sub     eax, 3000
               mov     ecx, eax
               mov     CurAddr, eax
            .if ecx < 91                            ; Max number of controls
               INVOKE     SetFocus, hREdit[ecx*4]
            .endif
               inc     Field
            .if Field == 13 ;12
                  and     Field, 0
                  inc     ScreenLine
            .endif
              call     DoStatus
               mov     eax, 1
               ret
         .endif
           call     DoStatus

      .elseif wmsg == WM_KEYUP
         .if wparam != 9 && wparam != 25h && wparam != 26h && wparam != 27h && wparam != 28h
               mov     ChangeOn, 1
              call     Update
              call     CheckState
         .endif

      .elseif wmsg == WM_LBUTTONDOWN
         .if hCurrent
            INVOKE     SendMessage, hCurrent, EM_SETSEL, 0, 0
         .endif
         INVOKE     GetWindowLong, hwnd, GWL_ID
            sub     eax, 3001
            mov     Field, eax
            mov     CurAddr, eax
            xor     edx, edx
            mov     ecx, 13
            div     ecx
            mov     ScreenLine, eax
            sub     Field, eax
         .if eax
               mov     ecx, 12
              imul     eax, ecx
               sub     Field, eax
         .endif
           call     DoStatus
           call     CheckState

      .elseif wmsg == WM_LBUTTONUP
         INVOKE     GetWindowLong, hwnd, GWL_ID
            sub     eax, 3001
          MOVmd     hCurrent, hREdit[eax*4]
           call     CheckState

      .elseif wmsg == WM_RBUTTONDOWN
            jmp     PopUp
      .endif
         jmp     ThatsAll

DoStatus:
         mov     ecx, ScreenLine
         inc     ecx
         add     ecx, TopLine
      INVOKE     BaseAscii, ecx, addr cnt1, 6, 10, 0, 1, 0
      INVOKE     BaseAscii, LineCnt, addr cnt2, 6, 10, 0, 1, 0
         mov     ecx, Field
         inc     ecx
      INVOKE     BaseAscii, ecx, addr cnt3, 4, 10, 0, 1, 0
      INVOKE     SendMessage, hWndStat, SB_SETTEXT, 1, addr LineData 
        retn

PopUp:
      INVOKE     GetWindowRect, hwnd, addr rect
         mov     ecx, lparam        ; x/y pos of window
         mov     ebx, ecx
         and     ebx, 0000ffffh     ; ebx = LOWORD(lparam) = x pos
         shr     ecx, 16            ; ecx = HIWORD(lparam) = y pos
         add     ebx, rect.left
         add     ecx, rect.top
      INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_LEFTBUTTON,\
                 ebx, ecx, 0, hWnd, addr rect
        jmp      ThatsAll

ThatsAll:
      INVOKE     CallWindowProc, lpRichEdit, hwnd, wmsg, wparam, lparam

         ret
RichEditProc ENDP

;==============================================================
; CheckState PROCEDURE
;==============================================================
CheckState PROC uses ebx edi
LOCAL    cr:CHARRANGE
LOCAL    TempWord:DWORD

      .if ChangeOn
            mov     TempWord, MF_ENABLED
      .else
            mov     TempWord, MF_GRAYED
      .endif
      INVOKE     EnableMenuItem, hMenu, IDM_SAVE, TempWord
         xor     TempWord, 1
         mov     ebx, 2
         mov     edi, IDM_SAVE
      .if !TempWord
            add     ebx, 6
            mov     edi, 112345
      .endif
      INVOKE     SendMessage, hWndTool, TB_SETCMDID, 2, edi
      INVOKE     SendMessage, hWndTool, TB_CHANGEBITMAP, edi, ebx

      INVOKE     IsClipboardFormatAvailable, CF_TEXT
      .if eax
            mov     TempWord, MF_ENABLED
      .else
            mov     TempWord, MF_GRAYED
      .endif
      INVOKE     EnableMenuItem, hSMenu, IDM_PASTE, TempWord
         xor     TempWord, 1
         mov     ebx, 5
         mov     edi, IDM_PASTE
      .if !TempWord
            add     ebx, 6
            mov     edi, 212345
      .endif
      INVOKE     SendMessage, hWndTool, TB_SETCMDID, 6, edi
      INVOKE     SendMessage, hWndTool, TB_CHANGEBITMAP, edi, ebx

      INVOKE     SendMessage, hCurrent, EM_EXGETSEL, 0, addr cr
         mov     eax, cr.cpMin
      .if eax != cr.cpMax
            mov     TempWord, MF_ENABLED
      .else
            mov     TempWord, MF_GRAYED
      .endif
      INVOKE     EnableMenuItem, hSMenu, IDM_CUT, TempWord
      INVOKE     EnableMenuItem, hSMenu, IDM_COPY, TempWord
      INVOKE     EnableMenuItem, hSMenu, IDM_DELETE, TempWord
         xor     TempWord, 1
         mov     ebx, 3
      .if !TempWord
            add     ebx, 6
      .endif
      INVOKE     SendMessage, hWndTool, TB_CHANGEBITMAP, IDM_CUT, ebx
         inc     ebx
      INVOKE     SendMessage, hWndTool, TB_CHANGEBITMAP, IDM_COPY, ebx
         add     ebx, 2
      INVOKE     SendMessage, hWndTool, TB_CHANGEBITMAP, IDM_DELETE, ebx
         ret

CheckState ENDP

;===============================================================
; Color PROCEDURE
;===============================================================
ChgColor PROC uses esi edi hdlg:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    cc:CHOOSECOLOR
LOCAL    hDC:DWORD, Ctrl, Incr, hNewBrush, Cnt, Cnt1, Len, hTemp, ID 

      .if wMsg == WM_INITDIALOG              ; If message is INITDIALOG then
         INVOKE     GetDlgItem, hdlg, 802
            mov     hTemp, eax
         INVOKE     EnableWindow, hTemp, 0

      .elseif wMsg == WM_CTLCOLORDLG || wMsg == WM_CTLCOLORSTATIC
         INVOKE     SetBkColor, wParam, NameAddrColor[36]
         INVOKE     SetTextColor, wParam, 00000000h
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, NameAddrColor[36]
            mov     hBR, eax
            ret

      .elseif wMsg == WM_PAINT || wMsg == WM_MOVE
         INVOKE     PostMessage, hColor, WM_COMMAND, 200, 0

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh
         .if eax == 200
              call     PaintColors

         .elseif eax > 200 && eax < 213
               mov     SaveCode, eax
               sub     eax, 201
               mov     edi, eax
               mov     esi, NameAddrColor[eax*4]
              call     DoColor
            .if SaveCode == 210 ; or RDW_INTERNALPAINT
               INVOKE     RedrawWindow, hdlg, 0, 0, RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
                 call     DoWindow
                 call     PaintColors
            .endif

ResetChg:
         .elseif eax == 801                 ; Defaults
               lea     esi, DefNAddrColor
               lea     edi, NameAddrColor
               mov     ecx, 12
            .while (ecx)
                  mov     eax, dword ptr[esi]
                  mov     dword ptr[edi], eax
                  add     esi, 4
                  add     edi, 4
                  dec     ecx
            .endw
              call     SetColors
            INVOKE     RedrawWindow, hdlg, 0, 0, RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
              call     DoWindow
              call     PaintColors

         .elseif eax == 802 && SaveCode     ; Undo last change
               mov     esi, ColorRes
               mov     edi, IncrRes
               mov     eax, SaveCode
               mov     wParam, eax
            INVOKE     GetDlgItem, hdlg, 802
               mov     hTemp, eax
            INVOKE     EnableWindow, hTemp, 0
              call     UndoChg
            .if SaveCode == 210 ; or RDW_INTERNALPAINT
               INVOKE     RedrawWindow, hdlg, 0, 0, RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
                 call     DoWindow
                 call     PaintColors
            .endif
               and     SaveCode, 0

         .elseif eax == 803                 ; Close
               jmp     CloseIt
         .endif

      .elseif wMsg == WM_CLOSE
            jmp     CloseIt
      .endif
         jmp     ColorDone

DoWindow:
      INVOKE     DeleteObject, hBrush
      INVOKE     CreateSolidBrush, NameAddrColor[36]
         mov     hBrush, eax
      INVOKE     SetClassLong, hWnd, GCL_HBRBACKGROUND, hBrush
      INVOKE     SendMessage, hWndStat, SB_SETBKCOLOR, 0, NameAddrColor[36]
      INVOKE     RedrawWindow, hWnd, 0, 0, RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
      INVOKE     ImageList_Destroy, hImageList

;---------- [Create the ImageList] ----------
      INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, 14, 0
         mov     hImageList, eax

;---------- [Load The Bitmaps] ----------
         mov     ID, 701           ; Bitmap ID start address
         mov     Cnt, 13           ; Number of bitmaps
      .while (Cnt)
         INVOKE     LoadImage, hInst, ID, IMAGE_BITMAP, 16, 16, LR_DEFAULTCOLOR
            mov     hTemp, eax
         INVOKE     ChgBmpColor, hTemp
            mov     hTemp ,eax
         INVOKE     ImageList_Add, hImageList, hTemp, NULL
         INVOKE     DeleteObject, hTemp
            inc     ID
            dec     Cnt
      .endw
      INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageList
        retn

PaintColors:
         xor     esi, esi
         mov     Ctrl, 201
         mov     Cnt, 13 ;22
      .while (Cnt)
         INVOKE     GetDlgItem, hdlg, Ctrl
            mov     hTemp, eax
         INVOKE     GetDC, hTemp
            mov     hDC, eax
         INVOKE     CreateSolidBrush, NameAddrColor[esi]
            mov     hNewBrush, eax
         INVOKE     GetClientRect, hTemp, addr rect
         INVOKE     FillRect, hDC, addr rect, hNewBrush
         INVOKE     DeleteObject, hNewBrush
         INVOKE     DeleteDC, hDC
            add     esi, 4
            inc     Ctrl
            dec     Cnt
      .endw
      INVOKE     UpdateWindow, hColor
        retn

DoColor:
;---------- [Set the CHOOSECOLOR attributes] ----------
      .if SaveCode
         INVOKE     GetDlgItem, hdlg, 802
            mov     hTemp, eax
         INVOKE     EnableWindow, hTemp, 1
      .endif
         mov     ColorRes, esi
         mov     IncrRes, edi
         mov     edx, esi
         and     esi, 00ffffffh
         and     edx, 0ff000000h
        push     edx
         mov     cc.lStructSize, sizeof cc
         mov     eax, hWnd
         mov     cc.hwndOwner, eax
         mov     eax, hInst
         mov     cc.hInstance, eax
         mov     cc.rgbResult, esi
         mov     cc.lpCustColors, offset CustClrs
         mov     cc.Flags, CC_FULLOPEN or CC_RGBINIT
      INVOKE     ChooseColor, addr cc
         pop     edx
      .if !eax                                ; Cancel'ed or error occurred
         INVOKE     SetFocus, hColor
            jmp     ColorRet
      .endif
         mov     esi, cc.rgbResult
         add     esi, edx

UndoChg:
         mov     NameAddrColor[edi*4], esi

SetColors:
         xor     esi, esi
         xor     edi, edi
         mov     Cnt, 91
         mov     Cnt1, 13
      .while (Cnt)
         INVOKE     SendMessage, hREdit[esi*4], EM_SETBKGNDCOLOR, 0, NameAddrColor[edi*4]
            inc     esi
            dec     Cnt
            dec     Cnt1
         .if !Cnt1
               inc     edi
               mov     Cnt1, 13
         .endif
      .endw
      INVOKE     SendMessage, hEdit, EM_SETBKGNDCOLOR, 0, NameAddrColor[36]

      INVOKE     RedrawWindow, hColor, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT
      INVOKE     UpdateWindow, hColor
      INVOKE     RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT
      INVOKE     SetFocus, hColor
        retn

CloseIt:
      .if hBR
         INVOKE     DeleteObject, hBR
            and     hBR, 0
      .endif
         and     hColor, 0
      INVOKE     DestroyWindow, hdlg     ; End the dialog
         mov     eax, TRUE               ; Return
         jmp     ColorRet                ; with TRUE

ColorDone:
         mov     eax, FALSE              ; Return with FALSE

ColorRet:
         ret

ChgColor ENDP

;===============================================================
; Find string PROCEDURE
;===============================================================
FindString PROC uses esi
LOCAL    Len:DWORD
LOCAL    szBuff[256]:BYTE

      INVOKE     RtlZeroMemory, addr szBuff, sizeof szBuff
      INVOKE     SendMessage, hEdit, WM_GETTEXT, sizeof szBuff, addr szBuff
      .if !eax
            ret
      .endif
         mov     Len, eax
      .if !FindNextOn
            and     IncrFind, 0
            mov     eax, LineCnt
            mov     Find1, eax
      .endif
      .while (Find1)
            mov     ecx, hLineStruc
            mov     eax, IncrFind
            mov     esi, [ecx+eax*4].LINE.rpLine
            xor     ecx, ecx
         .if !FindNextOn
               mov     Find2, sizeof NAMEADRESS
         .endif
            and     FindNextOn, 0
         .while (Find2)
               xor     edx, edx
               mov     eax, Len
               mov     Find3, eax
            .while (Find3)
                  mov     al, byte ptr[esi+ecx]
               .if al != byte ptr szBuff[edx]
                     inc     ecx
                     dec     Find2
                  .break
               .elseif Find3 == 1
                     jmp     FoundIt
               .endif
                  inc     ecx
                  inc     edx
                  dec     Find3
                  dec     Find2
            .endw
         .endw
            inc     IncrFind
            dec     Find1
      .endw
         and     FindNextOn, 0
      INVOKE     EnableWindow, hButt01, TRUE
      INVOKE     EnableWindow, hButt02, FALSE
      INVOKE     MessageBox, NULL, addr szError4, addr szBuff,\
                 MB_OK or MB_ICONWARNING or MB_SYSTEMMODAL
         ret

FoundIt:
         mov     FindNextOn, 1
         inc     IncrFind
         dec     Find1
      INVOKE     EnableWindow, hButt01, FALSE
      INVOKE     EnableWindow, hButt02, TRUE
         mov     eax, [esi].NAMEADRESS.LineNum
         dec     eax
         mov     TopLine, eax

      INVOKE     GetScrollInfo, hScrollV, SB_CTL, addr sci
        call     ScrollDown
         mov     eax, TopLine
        imul     eax, LineHgt
         mov     sci.nPos, eax
      .if LineCnt > 7
            mov     eax, LineCnt
            sub     eax, 6
           imul     eax, LineHgt
         .if sci.nPos > eax
               mov     sci.nPos, eax
         .endif
      .endif
      INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE
         mov     eax, sci.nPos
         mov     ScrollPos, eax

;INVOKE     MessageBox, NULL, addr szBuff, addr AppName, MB_OK
         ret


FindString ENDP

;=====================================================================
; Converts a Dec, Hex, Oct or Bin ascii string to a 32 bit num value.
;=====================================================================
AsciiBase PROC Input:DWORD, Output, Base
      pushad
         mov     esi, Input
         mov     edi, Output
         and     dword ptr[edi], 0
      INVOKE     lstrlen, Input
         xor     ecx, ecx
      .while (eax)
         .if byte ptr[esi+ecx] > 60h
               sub     byte ptr[esi+ecx], 57h
         .elseif byte ptr[esi+ecx] > 40h
               sub     byte ptr[esi+ecx], 37h
         .else
               xor     byte ptr[esi+ecx], 30h
         .endif
            dec     eax
            inc     ecx
      .endw
         mov     ebx, 1
         mov     esi, Input
         add     esi, ecx
         dec     esi
         xor     edx, edx
      .while (ecx)
            mov     al, byte ptr[esi]      ; Extract byte for conversion
            and     eax, 000000ffh
           imul     eax, ebx
            add     dword ptr[edi], eax    ; Accumulate output
           imul     ebx, Base
            dec     esi
            dec     ecx 
      .endw
       popad
          ret
AsciiBase ENDP

;=========================================================================
;  Converts a 32 bit num value to a Dec, Hex, Oct or Bin ascii string.
;=========================================================================
;INVOKE     BaseAscii, cnt, offset num, 2, 10, 0, 1, 0
BaseAscii PROC uses ebx esi InPut:DWORD, OutPut, LEN, Base, Comma, Fill, TermA
LOCAL    LBuff[32]: BYTE

      pushad
         xor     esi, esi
         mov     eax, InPut                ; Input
         mov     ebx, OutPut
         mov     byte ptr [ebx], '0'
      .while (eax)
            xor     edx, edx
            div     Base                   ; Base 10, 16, 8, 2
         .if dl > 9h
               add     dl, 37h             ; Convert to hex ASCII
         .else
               add     dl, 30h             ; Convert to dec ASCII
         .endif
            mov     LBuff[esi], dl
            inc     esi
         .if Comma == 1 && Base == 10 && eax > 0
            .if esi == 3 || esi == 7 || esi == 11
                  mov     LBuff[esi], 2ch  ; Insert commas
                  inc     esi
            .endif
         .endif
      .endw
         xor     edi, edi
         mov     ecx, esi
      .if LEN > ecx && Fill == 1           ; Zero fill
            xor     eax, eax
         .while (eax < LEN)
               mov     byte ptr [ebx+eax], '0'
               inc     eax
         .endw
            sub     LEN, ecx
            add     edi, LEN
      .endif
      .while (ecx)
            mov     al, byte ptr LBuff[esi-1]
            mov     byte ptr [ebx+edi], al
            inc     edi
            dec     esi
            dec     ecx
      .endw
      .if TermA
         mov     byte ptr [ebx+edi], 0h
      .endif
       popad
         ret
BaseAscii ENDP

;===================================
; Load file Procedure
;===================================
LoadFile PROC uses ebx esi edi
LOCAL    rect:RECT
LOCAL    Cnt:DWORD, Cnt1, IncrF, IncrL, IncrO
LOCAL    szBuff[256]:BYTE

         and     TopLine, 0
         and     ChangeOn, 0
         and     ZipOn, 0
         and     FirstNameOn, 0
         and     DescendingOn, 0

      .if PathName
;---------- [Clear edit controls, structurs, and line pointers
            xor     edi, edi
            mov     Cnt, 91
         .while (Cnt)
            INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr szNULL
               inc     edi
               dec     Cnt
         .endw

            and     IncrL, 0
            mov     eax, LineCnt
            mov     Cnt, eax
         .while (Cnt)
               mov     edx, hLineStruc
               mov     ecx, IncrL
               mov     edi, [edx+ecx*4].LINE.rpLine
            INVOKE     RtlZeroMemory, edi, sizeof NAMEADRESS
               inc     IncrL
               dec     Cnt
         .endw

         .if LineCnt
               xor     ecx, ecx
               mov     edx, hLineStruc
            .while (LineCnt)
                  mov     [edx+ecx*4].LINE.rpLine, 0
                  inc     ecx
                  dec     LineCnt
            .endw
            .if PathName == 4
                  mov     PathName, 0
                  mov     eax, -1
                  jmp     NoPath
            .endif
               jmp     HavePath
         .endif
      .endif
      INVOKE     GetCurrentDirectory, lengthof PathName, addr PathName
      INVOKE     lstrcat, addr PathName, addr szNameAdress
      INVOKE     GetFileAttributes, addr PathName

NoPath:
      .if eax == -1
            mov     LineCnt, 1
            mov     edi, hNAddressStruct
            mov     edx, hLineStruc
            mov     [edx].LINE.rpLine, edi
         INVOKE     SetWindowText, hWnd, addr AppName
            ret
      .endif

HavePath:
      INVOKE     SetWindowText, hWnd, addr PathName
         and     LineCnt, 0
         mov     ecx, hBuff
      INVOKE     lstrcpy, ecx, addr PathName
        call     ReadF
;DSPValue hWnd, sizeof NAMEADRESS, 1, 'm'

;---------- [Fill the structure
         and     IncrL, 0
         Mov     IncrO, 1
         xor     ebx, ebx
         mov     esi, hNameAddress
         mov     edi, hNAddressStruct
         mov     eax, BytesRead
         mov     Cnt, eax
      .while (Cnt)
            mov     al, byte ptr[esi]
         .if al != '^' && al != 0ah && al != 0dh
               mov     byte ptr szBuff[ebx], al
               mov     byte ptr szBuff[ebx+1], 0
               inc     ebx

         .elseif al == '^'
            .if byte ptr[esi-1] == '^'
                  mov     szBuff, 0
            .endif
            .if IncrO == 1
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.NameL, addr szBuff
            .elseif IncrO == 2
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.NameF, addr szBuff
            .elseif IncrO == 3
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.MI, addr szBuff
            .elseif IncrO == 4
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Address01, addr szBuff
            .elseif IncrO == 5
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Address02, addr szBuff
            .elseif IncrO == 6
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Address03, addr szBuff
            .elseif IncrO == 7
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Zip, addr szBuff
            .elseif IncrO == 8
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.PhoneA, addr szBuff
            .elseif IncrO == 9
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Phone, addr szBuff
            .elseif IncrO == 10
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.FaxA, addr szBuff
            .elseif IncrO == 11
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Fax, addr szBuff
            .elseif IncrO == 12
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Email, addr szBuff
            .elseif IncrO == 13
               INVOKE     lstrcpy, addr [edi].NAMEADRESS.Comments, addr szBuff
            .endif
               xor     ebx, ebx
               inc     IncrO

         .elseif al == 0ah
               inc     LineCnt
               mov     ecx, IncrL
               mov     [edi].NAMEADRESS.LineNum, ecx
               mov     edx, hLineStruc
               mov     [edx+ecx*4].LINE.rpLine, edi
               inc     IncrL
               add     edi, sizeof NAMEADRESS
               mov     IncrO, 1
         .endif
            inc     esi
            dec     Cnt
      .endw
         mov     ClearPointer, edi                  ; For non ascending LName sequence

;---------- [Fill the edit fields
         and     IncrL, 0
         xor     edi, edi
         mov     edx, hLineStruc
         mov     ecx, IncrL
         mov     esi, [edx+ecx*4].LINE.rpLine
         mov     eax, LineCnt
      .if eax > 7
            mov     eax, 7
      .endif
         mov     Cnt, eax
      .while (Cnt)
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameL
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameF
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.MI
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address01
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address02
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address03
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Zip
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.PhoneA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Phone
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.FaxA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Fax
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Email
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Comments
            inc     edi
            inc     IncrL
            mov     edx, hLineStruc
            mov     ecx, IncrL
            mov     esi, [edx+ecx*4].LINE.rpLine
            dec     Cnt
      .endw
;         mov     FirstNameOn, 1
;        call     Sort
         and     FirstNameOn, 0
        call     Sort
        call     SetScroll

         ret
LoadFile ENDP

;===================================
; Set Scroll Procedure
;===================================
SetScroll PROC

         mov     ecx, LineCnt
         inc     ecx
         mov     eax, LineHgt                   ; Height of line
        imul     ecx, eax
         mov     edx, 7                         ; Total lines per screen
         mov     eax, LineHgt
        imul     edx, eax
         mov     sci.nMin, 0
         mov     sci.nMax, ecx
         mov     sci.nPage, edx
      INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE

         ret
SetScroll ENDP

;===================================
; Update the structure Procedure
;===================================
Update PROC uses esi edi
LOCAL    NextAddr:DWORD
LOCAL    szBuff[256]:BYTE

;---------- [Get highest line address in case columns were sorted
         and     NextAddr, 0
         mov     esi, hLineStruc
         xor     edx, edx
         mov     ecx, LineCnt
      .while (ecx)
            mov     eax, [esi+edx*4].LINE.rpLine
         .if eax > NextAddr
               mov     NextAddr, eax
         .endif
            inc     edx
            dec     ecx
      .endw
         
         mov     esi, CurAddr
         mov     ecx, TopLine
         add     ecx, ScreenLine
         mov     eax, LineCnt
         dec     eax
         mov     edx, hLineStruc
         mov     edi, [edx+ecx*4].LINE.rpLine
      .if ecx > eax
            mov     edi, NextAddr ;[edx+eax*4].LINE.rpLine
            add     edi, sizeof NAMEADRESS
            inc     eax
            mov     [edi].NAMEADRESS.LineNum, eax
            mov     [edx+eax*4].LINE.rpLine, edi
            mov     eax, edi
            add     eax, sizeof NAMEADRESS*2
            mov     ClearPointer, eax                  ; For non ascending LName sequence
            inc     LineCnt
           call     SetScroll
      .endif

      INVOKE     SendMessage, hREdit[esi*4], WM_GETTEXT, sizeof szBuff, addr szBuff
      .if Field == 0
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.NameL, addr szBuff
      .elseif Field == 1
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.NameF, addr szBuff
      .elseif Field == 2
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.MI, addr szBuff
      .elseif Field == 3
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Address01, addr szBuff
      .elseif Field == 4
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Address02, addr szBuff
      .elseif Field == 5
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Address03, addr szBuff
      .elseif Field == 6
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Zip, addr szBuff
      .elseif Field == 7
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.PhoneA, addr szBuff
      .elseif Field == 8
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Phone, addr szBuff
      .elseif Field == 9
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.FaxA, addr szBuff
      .elseif Field == 10
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Fax, addr szBuff
      .elseif Field == 11
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Email, addr szBuff
      .elseif Field == 12
         INVOKE     lstrcpy, addr [edi].NAMEADRESS.Comments, addr szBuff
      .endif
         ret

Update ENDP

;===================================
; ScrollDown Procedure
;===================================
ScrollDown PROC uses esi edi
LOCAL    Cnt:DWORD, Cnt1, IncrL
LOCAL    szBuff[256]:BYTE

         mov     eax, LineCnt
         sub     eax, TopLine
      .if eax <= 1
            ret
      .endif

         inc     TopLine
         mov     ecx, TopLine
         mov     IncrL, ecx
         mov     edx, hLineStruc
         mov     esi, [edx+ecx*4].LINE.rpLine
         xor     edi, edi
         mov     eax, LineCnt
      .if eax > 7
            mov     eax, 7
      .endif
         mov     Cnt, eax
      .while (Cnt)
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameL
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameF
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.MI
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address01
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address02
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address03
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Zip
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.PhoneA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Phone
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.FaxA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Fax
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Email
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Comments
            inc     edi
            inc     IncrL
            mov     edx, hLineStruc
            mov     ecx, IncrL
         .if ecx >= LineCnt
               add     esi, sizeof NAMEADRESS
;            .if DescendingOn || FirstNameOn || ZipOn
                  mov     esi, ClearPointer
;            .endif
               mov     [edx+ecx*4].LINE.rpLine, esi
         .endif
            mov     esi, [edx+ecx*4].LINE.rpLine
            dec     Cnt
      .endw

;---------- [Repaint the edit controls
         xor     edx, edx
         mov     eax, TopLine
         mov     ecx, 7           ; Number of lines per screen
         div     ecx
         xor     esi, esi
         mov     edi, edx         ; Remainder
         mov     Cnt, 91          ; Total edit controls
         mov     Cnt1, 13         ; Number of controls per line
      .while (Cnt)
         INVOKE     SendMessage, hREdit[esi*4], EM_SETBKGNDCOLOR, 0, NameAddrColor[edi*4]
            inc     esi
            dec     Cnt
            dec     Cnt1
         .if !Cnt1
               inc     edi
            .if edi >= 7
                  xor     edi, edi
            .endif
               mov     Cnt1, 13
         .endif
      .endw

         ret
ScrollDown ENDP

;===================================
; ScrollUp Procedure
;===================================
ScrollUp PROC uses esi edi
LOCAL    Cnt:DWORD, Cnt1, IncrL
LOCAL    szBuff[256]:BYTE

         dec     TopLine
         mov     ecx, TopLine
         mov     IncrL, ecx
         mov     edx, hLineStruc
         mov     esi, [edx+ecx*4].LINE.rpLine
         xor     edi, edi
         mov     eax, LineCnt
      .if eax > 7
            mov     eax, 7
      .endif
         mov     Cnt, eax
      .while (Cnt)
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameL
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameF
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.MI
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address01
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address02
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address03
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Zip
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.PhoneA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Phone
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.FaxA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Fax
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Email
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Comments
            inc     edi
            inc     IncrL
            mov     edx, hLineStruc
            mov     ecx, IncrL
            mov     esi, [edx+ecx*4].LINE.rpLine
            dec     Cnt
      .endw

;---------- [Repaint the edit controls
         xor     edx, edx
         mov     eax, TopLine
         mov     ecx, 7           ; Number of lines per screen
         div     ecx
         xor     esi, esi
         mov     edi, edx
         mov     Cnt, 91          ; Total edit controls
         mov     Cnt1, 13         ; Number of controls per line
      .while (Cnt)
         INVOKE     SendMessage, hREdit[esi*4], EM_SETBKGNDCOLOR, 0, NameAddrColor[edi*4]
            inc     esi
            dec     Cnt
            dec     Cnt1
         .if !Cnt1
               inc     edi
            .if edi >= 7
                  xor     edi, edi
            .endif
               mov     Cnt1, 13
         .endif
      .endw

         ret
ScrollUp ENDP

;===============================================================
; Open file PROCEDURE
;===============================================================
OpenFileA  PROC
LOCAL    ofn:OPENFILENAME
LOCAL    EditS:EDITSTREAM
LOCAL    hFile:DWORD

      .if ChangeOn
         INVOKE     MessageBox, NULL, addr szError2, addr AppName,
                    MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_SYSTEMMODAL
         .if eax == IDYES
              call     SaveFile
         .endif
      .endif

;---------- [Zero out the structures] ----------
      INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
         mov     byte ptr PathName, 0

;---------- [Set the OPENFILENAME attributes] ----------
         mov     ofn.lStructSize, sizeof ofn
         mov     eax, hWnd
         mov     ofn.hwndOwner, eax
         mov     eax, hInst
         mov     ofn.hInstance, eax
         mov     ofn.lpstrFilter, offset szFilter
         mov     ofn.lpstrFile, offset PathName
         mov     ofn.nMaxFile, lengthof PathName
         mov     ofn.lpstrFileTitle, offset FileName
         mov     ofn.nMaxFileTitle, lengthof FileName
         mov     ofn.lpstrTitle, offset szOpenTitle
         mov     ofn.Flags, OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
      INVOKE     GetOpenFileName, addr ofn
      .if !eax                       ; Cancel'ed or error occurred
            jmp     EndOpen
      .endif

        call     LoadFile

EndOpen:
           ret

OpenFileA  ENDP

;===================================
; Save file Procedure
;===================================
SaveFile PROC uses ebx esi edi
LOCAL    ofn:OPENFILENAME
LOCAL    Cnt:DWORD, Cnt1, IncrF, IncrL, IncrO
LOCAL    szBuff[256]:BYTE

;---------- [Write the structure array out
            and     IncrL, 0
            mov     edx, hLineStruc
            mov     ecx, IncrL
            mov     esi, [edx+ecx*4].LINE.rpLine
            mov     edi, hNameAddress
            mov     byte ptr[edi], 0
            mov     eax, LineCnt
            mov     Cnt, eax
         .while (Cnt)
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.NameL
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.NameF
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.MI
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Address01
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Address02
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Address03
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Zip
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.PhoneA
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Phone
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.FaxA
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Fax
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Email
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr [esi].NAMEADRESS.Comments
            INVOKE     lstrcat, edi, addr szCar
            INVOKE     lstrcat, edi, addr szCRLF
               inc     IncrL
               mov     edx, hLineStruc
               mov     ecx, IncrL
               mov     esi, [edx+ecx*4].LINE.rpLine
               dec     Cnt
         .endw
         INVOKE     lstrcat, edi, addr szNULL

            and     BytesRead, 0
            mov     al, byte ptr[edi]
         .while (al != 0)
               mov     al, byte ptr[edi]
               inc     BytesRead
               inc     edi
         .endw
            dec     BytesRead
;         INVOKE     GetCurrentDirectory, lengthof PathName, addr PathName
;         INVOKE     lstrcat, addr PathName, addr szNameAdress
         .if SaveFlag == 1 || !PathName
            INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
               mov     ofn.lStructSize, sizeof ofn
               mov     eax, hWnd
               mov     ofn.hwndOwner, eax
               mov     eax, hInst
               mov     ofn.hInstance, eax
               mov     ofn.lpstrFilter, offset szFilter
               mov     ofn.lpstrFile, offset PathName
               mov     ofn.nMaxFile, lengthof PathName
               mov     ofn.lpstrFileTitle, offset FileName
               mov     ofn.nMaxFileTitle, lengthof FileName
               mov     ofn.lpstrTitle, offset szSaveTitle
               mov     ofn.Flags, OFN_OVERWRITEPROMPT or OFN_CREATEPROMPT or\
                       OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
            INVOKE     GetSaveFileName, addr ofn
            .if !eax                       ; Cancel'ed or error occurred
                  mov     eax, IDCANCEL
                  jmp     EndSave
            .endif
         .endif

            mov     ecx, hBuff
         INVOKE     lstrcpy, ecx, addr PathName
           call     WriteF

            and     ChangeOn, 0
           call     CheckState
         INVOKE     SetWindowText, hWnd, addr PathName

EndSave:
         and     SaveFlag, 0
         ret

SaveFile ENDP

;===================================
; Read file Procedure
;===================================
ReadF PROC
LOCAL    hFile:DWORD

         mov     ecx, hBuff
      INVOKE     CreateFile, ecx,\
                 GENERIC_READ or GENERIC_WRITE ,\
                 FILE_SHARE_READ or FILE_SHARE_WRITE,\
                 0, OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE, 0
      .if eax == -1
         INVOKE     MessageBox, NULL, addr szError1, addr ClassName,\
                    MB_OK or MB_ICONWARNING or MB_SYSTEMMODAL
            mov     eax, -1
      .else
            mov     hFile, eax
         INVOKE     ReadFile, hFile, hNameAddress, 2000000, addr BytesRead, NULL
            mov     eax, hNameAddress
            mov     ecx, BytesRead
            mov     byte ptr [eax+ecx], 0
         INVOKE     CloseHandle, hFile
      .endif

         ret
ReadF ENDP

;===================================================
; Write file PROCEDURE
;===================================================
WriteF PROC
LOCAL    hFile:DWORD, BytesOut

         mov     ecx, hBuff
      INVOKE     CreateFile, ecx,\
                 GENERIC_READ or GENERIC_WRITE ,\
                 FILE_SHARE_READ or FILE_SHARE_WRITE,\
                 NULL, CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,\
                 NULL
      .if eax == INVALID_HANDLE_VALUE
         INVOKE     MessageBox, NULL, addr szError3, addr ClassName,\
                    MB_OK or MB_ICONWARNING or MB_SYSTEMMODAL
            xor     eax, eax
            jmp     NoFile
      .endif
         mov     hFile, eax
      INVOKE     WriteFile, hFile, hNameAddress, BytesRead, addr BytesOut, NULL
        push     eax
      INVOKE     CloseHandle, hFile
         pop     eax

NoFile:
         ret
WriteF ENDP

;===================================================
; Sort procedure
;===================================================
Sort PROC uses ebx esi edi
LOCAL    Var1:DWORD, hMem, Savebx, ecxedx, ecxOn, LowRef, HighRef, Pivot
LOCAL    szBuff1[256]:BYTE, szBuff2[256]:BYTE

         and     Var1, 0
         and     Pivot, 0

      .if FirstNameOn
            mov     eax, offset NAMEADRESS.NameF
            sub     eax, offset NAMEADRESS
            mov     Var1, eax
      .endif
      .if ZipOn
            mov     eax, offset NAMEADRESS.Zip
            sub     eax, offset NAMEADRESS
            mov     Var1, eax
      .endif
         mov     esi, hLineStruc

         xor     ecx, ecx
         mov     edi, LineCnt
      .while (edi)
            mov     eax, [esi+ecx*4]
;DSPValue hWnd, eax, 1, 'm'
            inc     ecx
            dec     edi
      .endw

;---------- [Allocate work buffer
         mov     ecx, LineCnt
        imul     ecx, 4
        imul     ecx, 13                 ; Number of columns
      INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, ecx
         mov     hMem, eax
         mov     edi, hMem               ; Load work buffer address in edi

;---------- [Set Low and High reference values
         mov     LowRef, 0
         mov     eax, LineCnt
         dec     eax
         mov     HighRef, eax            ; HighRef = LineCnt - 1

OuterLoop:
;---------- [Calculate midpoint for pivot
         mov     eax, HighRef
         add     eax, LowRef
         shr     eax, 1
         mov     ebx, [esi+eax*4]        ; Pivot point in ebx
         mov     Savebx, ebx
         mov     ecx, LowRef
         mov     edx, HighRef

;____________________________________________________________________
InnerLoop:
         mov     ecxedx, ecx
         and     ecxOn, 0
        call     Compare
      .if !DescendingOn && sdword ptr eax >= 0
            jmp     InInner              ; Ascending
      .elseif DescendingOn && sdword ptr eax <= 0
            jmp     InInner              ; Descending
      .endif
         inc     ecx
         jmp     InnerLoop

InInner:
         mov     ecxedx, edx
         mov     ecxOn, 1
        call     Compare
      .if !DescendingOn && sdword ptr eax >= 0
            jmp     ChkInner             ; Ascending
      .elseif DescendingOn && sdword ptr eax <= 0
            jmp     ChkInner             ; Descending
      .endif
         dec     edx
         jmp     InInner

ChkInner:
         cmp     ecx, edx
          jg     ExitInner

;---------- [Swap elements
         mov     eax, [esi+ecx*4]
         mov     ebx, [esi+edx*4]
         mov     [esi+ecx*4], ebx
         mov     [esi+edx*4], eax

;---------- [Restore ebx
         mov     ebx, Savebx
         inc     ecx
         dec     edx
         cmp     ecx, edx
         jle     InnerLoop
;____________________________________________________________________

ExitInner:
         cmp     ecx, HighRef
          jg     ChkOuter

;---------- [Copy to work buffer
         mov     eax, Pivot
         mov     [edi+eax*4], ecx
         mov     ebx, HighRef
         mov     [edi+eax*4+4], ebx
         add     Pivot, 2

ChkOuter:
         mov     ebx, Savebx
         mov     HighRef, edx
         cmp     edx, LowRef
          jg     OuterLoop

         cmp     Pivot, 0
         jz      GetOut

;---------- [Copy from work buffer
         sub     Pivot, 2
         mov     eax, Pivot
         mov     ebx, [edi+eax*4]
         mov     LowRef, ebx
         mov     ebx, [edi+eax*4+4]
         mov     HighRef, ebx
         mov     ebx, Savebx             ; Restore ebx
         jmp     OuterLoop

;____________________________________________________________________
Compare:

; You can use this routine instead of the following routine if you
; don't want to keep the previous name sort column in sequence
;********************************************
;        push     ecx
;        push     edx
;         mov     eax, ecxedx
;      .if ecxOn
;            mov     edx, [esi+eax*4]
;            mov     ecx, ebx
;      .else
;            mov     ecx, [esi+eax*4]
;            mov     edx, ebx
;      .endif
;         add     ecx, Var1               ; Offset for sort fields
;         add     edx, Var1               ; Offset for sort fields
;      INVOKE     lstrcmp, ecx, edx
;         pop     edx
;         pop     ecx
;*********************************************

        push     ecx
        push     edx
        push     esi
        push     edi
         mov     eax, ecxedx
      .if ecxOn
            mov     edi, [esi+eax*4]
            mov     esi, ebx
      .else
            mov     esi, [esi+eax*4]
            mov     edi, ebx
      .endif
         add     esi, Var1               ; Offset for sort fields
         add     edi, Var1               ; Offset for sort fields
      .if Var1 == offset NAMEADRESS.Zip - offset NAMEADRESS
         INVOKE     lstrcmp, esi, edi

      .else
         INVOKE     lstrcpy, addr szBuff1, esi
         .if !Var1
               add     esi, 32           ; Length of name fields
         .else
               sub     esi, 32
         .endif
         INVOKE     lstrcat, addr szBuff1, esi
         INVOKE     lstrcpy, addr szBuff2, edi
         .if !Var1
               add     edi, 32
         .else
               sub     edi, 32
         .endif
         INVOKE     lstrcat, addr szBuff2, edi
         INVOKE     lstrcmp, addr szBuff1, addr szBuff2
      .endif
         pop     edi
         pop     esi
         pop     edx
         pop     ecx
        retn
;____________________________________________________________________

GetOut:
      INVOKE     HeapFree, hDefHeap, 0, hMem

         mov     esi, hLineStruc
         xor     ecx, ecx
         mov     edi, LineCnt
      .while (edi)
            mov     eax, [esi+ecx*4]
;DSPValue hWnd, eax, 1, 'm'
            inc     ecx
            dec     edi
      .endw
        call     ReLoad
         ret

Sort ENDP

;===================================
; Load file Procedure
;===================================
ReLoad PROC uses ebx esi edi
LOCAL    Cnt:DWORD, Cnt1, IncrL

         and     sci.nPos, 0
         and     ScrollPos, 0
         and     TopLine, 0
      INVOKE     SetScrollInfo, hScrollV, SB_CTL, addr sci, TRUE

;---------- [Fill the edit fields
         and     IncrL, 0
         xor     edi, edi
         mov     edx, hLineStruc
         mov     ecx, IncrL
         mov     esi, [edx+ecx*4].LINE.rpLine
         mov     eax, LineCnt
      .if eax > 7 ;21
            mov     eax, 7 ;21
      .endif
         mov     Cnt, eax
      .while (Cnt)
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameL
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.NameF
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.MI
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address01
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address02
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Address03
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Zip
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.PhoneA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Phone
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.FaxA
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Fax
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Email
            inc     edi
         INVOKE     SendMessage, hREdit[edi*4], WM_SETTEXT, 0, addr [esi].NAMEADRESS.Comments
            inc     edi
            inc     IncrL
            mov     edx, hLineStruc
            mov     ecx, IncrL
            mov     esi, [edx+ecx*4].LINE.rpLine
            dec     Cnt
      .endw

         xor     edx, edx
         mov     eax, TopLine
         mov     ecx, 7
         div     ecx
         xor     esi, esi
         mov     edi, edx
         mov     Cnt, 91
         mov     Cnt1, 13
      .while (Cnt)
         INVOKE     SendMessage, hREdit[esi*4], EM_SETBKGNDCOLOR, 0, NameAddrColor[edi*4]
            inc     esi
            dec     Cnt
            dec     Cnt1
         .if !Cnt1
               inc     edi
            .if edi >= 7
                  xor     edi, edi
            .endif
               mov     Cnt1, 13
         .endif
      .endw

         xor     eax, eax
         mov     ecx, LineCnt
      .while (ecx)
            mov     edx, hLineStruc
            mov     edi, [edx+eax*4].LINE.rpLine
            mov     [edi].NAMEADRESS.LineNum, eax
            inc     eax
            dec     ecx
      .endw

         ret

ReLoad ENDP

;===================================================
; ChgBmpColor procedure
;===================================================
ChgBmpColor PROC hBitmap:DWORD
LOCAL    mDC:DWORD, hNewBrush, hOldBmp, Fill, hOldBrush

      INVOKE     CreateCompatibleDC, NULL
         mov     mDC, eax
      INVOKE     SelectObject, mDC, hBitmap
         mov     hOldBmp, eax
      INVOKE     GetSysColor, COLOR_BTNFACE
      INVOKE     CreateSolidBrush, NameAddrColor[36] ;eax
         mov     hNewBrush, eax
      INVOKE     SelectObject, mDC, hNewBrush
         mov     hOldBrush, eax
         mov     Fill, 00c0c0c0h
      INVOKE     ExtFloodFill, mDC, 0, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 0, 15, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 15, Fill, FLOODFILLSURFACE
      INVOKE     SelectObject, mDC, hOldBrush
      INVOKE     DeleteObject, hNewBrush
      INVOKE     SelectObject, mDC, hBitmap
        push     eax
      INVOKE     DeleteDC, mDC
         pop     eax
         ret

ChgBmpColor ENDP

;===================================================
; Registry Query for text strings
;===================================================
RegQuerySZ PROC ValueName:DWORD, Default
LOCAL    hReg:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szNameAddr, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp
      INVOKE     RegQueryValueEx, hReg, ValueName, 0, addr lpType, Default, addr lpcbData
        push     eax
      INVOKE     RegCloseKey, hReg
         pop     eax
         ret

RegQuerySZ  ENDP

;===================================================
; Saves information about AsmEdit to the registry
;===================================================
RegSave PROC
LOCAL    hReg:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szNameAddr, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp

      INVOKE     RegSetValueEx, hReg, addr szNAddrColor, 0, REG_BINARY,\
                 addr NameAddrColor, sizeof NameAddrColor
      INVOKE     RegSetValueEx, hReg, addr szCustClrs, 0, REG_BINARY, addr CustClrs, sizeof CustClrs
      INVOKE     RegCloseKey, hReg

         ret
RegSave ENDP

end start
